/*
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.acroynon.springdatarestexample.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.acroynon.springdatarestexample.client.model.EntityModelTransportCall;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import com.acroynon.springdatarestexample.client.common.JSON;

/**
 * PagedModelEntityModelTransportCallEmbedded
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class PagedModelEntityModelTransportCallEmbedded {
  public static final String SERIALIZED_NAME_TRANSPORT_CALLS = "transportCalls";
  @SerializedName(SERIALIZED_NAME_TRANSPORT_CALLS)
  private List<EntityModelTransportCall> transportCalls = null;

  public PagedModelEntityModelTransportCallEmbedded() { 
  }

  public PagedModelEntityModelTransportCallEmbedded transportCalls(List<EntityModelTransportCall> transportCalls) {
    
    this.transportCalls = transportCalls;
    return this;
  }

  public PagedModelEntityModelTransportCallEmbedded addTransportCallsItem(EntityModelTransportCall transportCallsItem) {
    if (this.transportCalls == null) {
      this.transportCalls = new ArrayList<>();
    }
    this.transportCalls.add(transportCallsItem);
    return this;
  }

   /**
   * Get transportCalls
   * @return transportCalls
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public List<EntityModelTransportCall> getTransportCalls() {
    return transportCalls;
  }


  public void setTransportCalls(List<EntityModelTransportCall> transportCalls) {
    this.transportCalls = transportCalls;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PagedModelEntityModelTransportCallEmbedded pagedModelEntityModelTransportCallEmbedded = (PagedModelEntityModelTransportCallEmbedded) o;
    return Objects.equals(this.transportCalls, pagedModelEntityModelTransportCallEmbedded.transportCalls);
  }

  @Override
  public int hashCode() {
    return Objects.hash(transportCalls);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PagedModelEntityModelTransportCallEmbedded {\n");
    sb.append("    transportCalls: ").append(toIndentedString(transportCalls)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("transportCalls");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PagedModelEntityModelTransportCallEmbedded
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (PagedModelEntityModelTransportCallEmbedded.openapiRequiredFields.isEmpty()) {
          return;
        } else { // has required fields
          throw new IllegalArgumentException(String.format("The required field(s) %s in PagedModelEntityModelTransportCallEmbedded is not found in the empty JSON string", PagedModelEntityModelTransportCallEmbedded.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PagedModelEntityModelTransportCallEmbedded.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PagedModelEntityModelTransportCallEmbedded` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      JsonArray jsonArraytransportCalls = jsonObj.getAsJsonArray("transportCalls");
      if (jsonArraytransportCalls != null) {
        // ensure the json data is an array
        if (!jsonObj.get("transportCalls").isJsonArray()) {
          throw new IllegalArgumentException(String.format("Expected the field `transportCalls` to be an array in the JSON string but got `%s`", jsonObj.get("transportCalls").toString()));
        }

        // validate the optional field `transportCalls` (array)
        for (int i = 0; i < jsonArraytransportCalls.size(); i++) {
          EntityModelTransportCall.validateJsonObject(jsonArraytransportCalls.get(i).getAsJsonObject());
        };
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PagedModelEntityModelTransportCallEmbedded.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PagedModelEntityModelTransportCallEmbedded' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PagedModelEntityModelTransportCallEmbedded> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PagedModelEntityModelTransportCallEmbedded.class));

       return (TypeAdapter<T>) new TypeAdapter<PagedModelEntityModelTransportCallEmbedded>() {
           @Override
           public void write(JsonWriter out, PagedModelEntityModelTransportCallEmbedded value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PagedModelEntityModelTransportCallEmbedded read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PagedModelEntityModelTransportCallEmbedded given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PagedModelEntityModelTransportCallEmbedded
  * @throws IOException if the JSON string is invalid with respect to PagedModelEntityModelTransportCallEmbedded
  */
  public static PagedModelEntityModelTransportCallEmbedded fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PagedModelEntityModelTransportCallEmbedded.class);
  }

 /**
  * Convert an instance of PagedModelEntityModelTransportCallEmbedded to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

